#!/bin/csh
# usage : calc.cm.mac atom:ratio ...
#
set pwd=`dirname $0`
#
set tbl=${pwd}/index.tbl
set dir=${pwd}/ln
#
set tmp=/tmp/AAAa$$
#
if ($#argv < 1) then
  stderr usage : calc.cm.mac atom:ratio ... ; exit 1
endif
#
set awk1=('NR==1 { atom=$1 }' \
          'NR>=2 { if (atom==$4) atom=$1 }' \
          'END   { print atom }')
set awk2=('NR==1 { ratio=$1 }' \
          'NR==2 { printf "%f\n",$2*ratio }')
set zws=''
foreach arg ($argv)
  set ar=(`echo $arg | tr ':' ' '`)
  if ($#ar != 2) then
    stderr $arg : bad atom:ratio format. ; exit 1
  endif
  if (`echo $ar[2] | awk '{ if ($1>=0) print 1; else print 0 }'` == 0) then
    stderr $arg / $ar[2] : bad number ratio of the atom. ; exit 1
  endif
#
  set z=`( echo $ar[1] ; cat $tbl ) | awk "$awk1"`
  if (!(-e ${dir}/${z}.gz)) then
    stderr $arg / ${dir}/${z}.gz : file not found. ; exit 1
  endif
#
  set zws=($zws ${z}:`( echo $ar[2] ; grep "^$z" $tbl ) | awk "$awk2"`)
end
#
( echo 0 ; awk '{ for (nf=1; nf<=NF; nf++) printf "%f\n",$nf }' ) >$tmp
#
set awk=('BEGIN { N=0 }' \
         'NF==5 { ++N; x[N]=$1; y0[N]=$2; y1[N]=$3; y2[N]=$4; y3[N]=$5 }' \
         'NF==3 { ++N; x[N]=$1; y0[N]=$2; y1[N]=$3; y2[N]=0; y3[N]=0 }' \
         'NF==2 { ++N; x[N]=$1; y0[N]=$2; y1[N]=0; y2[N]=0; y3[N]=0 }' \
         'NF==1 { if (N>0) {' \
          'for (n=2; n<=N; n++) if ($1<x[n]) break; --n; t=$1-x[n];' \
          'printf "%f\n",exp(y0[n]+y1[n]*t+y2[n]*t*t+y3[n]*t*t*t) }}')
foreach zw ($zws)
  ( echo $zw | cut -d: -f2 ; \
  ( gzip -d -c ${dir}/`echo $zw | cut -d: -f1`.gz ; \
    sed -n 2,\$p $tmp | cut -f1 ) | awk "$awk" ) | \
  paste $tmp - >${tmp}.tmp ; mv ${tmp}.tmp $tmp
end
#
set awk=('NR==1 { sum=0; for (nf=2; nf<=NF; nf++) sum+=$nf;' \
                 'for (nf=2; nf<=NF; nf++) weight[nf]=$nf/sum }' \
         'NR>=2 { sum=0; for (nf=2; nf<=NF; nf++) sum+=($nf*weight[nf]);' \
                 'printf "%f\t%f\n",$1,sum }')
awk "$awk" $tmp ; rm $tmp
