#!/bin/csh
# usage : calc.em.mac atom
#
set pwd=`dirname $0`
#
set tbl=${pwd}/index.tbl
set dir=${pwd}/ln
#
if ($#argv != 1) then
  stderr usage : calc.em.mac atom ; exit 1
endif
#
set atom=$argv[1]
#
set awk=('NR==1 { atom=$1 }' \
         'NR>=2 { if (atom==$4) atom=$1 }' \
         'END   { print atom }')
set z=`( echo $atom ; cat $tbl ) | awk "$awk"`
#
set ln=${dir}/${z}.gz
if (!(-e $ln)) then
  stderr $ln : file not found. ; exit 1
endif
#
set awk1='{ for (nf=1; nf<=NF; nf++) printf "%f\n",$nf }'
set awk2=('BEGIN { N=0 }' \
          'NF==5 { ++N; x[N]=$1; y0[N]=$2; y1[N]=$3; y2[N]=$4; y3[N]=$5 }' \
          'NF==3 { ++N; x[N]=$1; y0[N]=$2; y1[N]=$3; y2[N]=0; y3[N]=0 }' \
          'NF==2 { ++N; x[N]=$1; y0[N]=$2; y1[N]=0; y2[N]=0; y3[N]=0 }' \
          'NF==1 { if (N>0) {' \
           'for (n=2; n<=N; n++) if ($1<x[n]) break; --n; t=$1-x[n];' \
           'printf "%f\t%f\n",$1,exp(y0[n]+y1[n]*t+y2[n]*t*t+y3[n]*t*t*t) }}')
( gzip -d -c $ln ; awk "$awk1" ) | awk "$awk2"
