#!/bin/csh
set pwd=`dirname $0`
#
if (-e ${pwd}/ln) exit 1
#
mkdir ${pwd}/ln
#
set tmp=/tmp/AAAa$$
#
cat <<'fin' >$tmp
  BEGIN {
    BoundaryCondition=2; e=0; N=0
  }
  function Print(N,x,y) {
    if (N==0) return
    if (N==1) {
      printf "%f\t%f\t0\t0\t0\n",x[1],y[1] ; return
    }
    if (N==2) {
      printf "%f\t%f\t%f\t0\t0\n",x[1],y[1],(y[2]-y[1])/(x[2]-x[1]) ; return
    }
    for (n=2; n<=N; n++) {
      h[n]=x[n]-x[n-1]
      v[n]=y[n]-y[n-1]
    }
    for (n=2; n<N; n++) {
      a[n]=h[n+1]/(h[n]+h[n+1])
      b[n]=1-a[n]
      g[n]=3*(a[n]*v[n]/h[n]+b[n]*v[n+1]/h[n+1])
    }
    b[1]=BoundaryCondition; g[1]=(BoundaryCondition+2)*v[2]/h[2]
    a[N]=BoundaryCondition; g[N]=(BoundaryCondition+2)*v[N]/h[N]
    p[1]=2
    q[1]=g[1]
    for (n=2; n<=N; n++) {
      c=a[n]/p[n-1]; p[n]=2   -b[n-1]*c
                     q[n]=g[n]-q[n-1]*c
    }
    d[N]=q[N]/p[N]
    for (n=N-1; n>=1; n--) d[n]=(q[n]-b[n]*d[n+1])/p[n]
    for (n=1; n<N; n++) {
      printf "%f\t",x[n]
      printf "%f\t",y[n]
      printf "%f\t",d[n]
      printf "%f\t",(3*v[n+1]-(d[n+1]+2*d[n])*h[n+1])/(h[n+1]*h[n+1])
      printf "%f\n",((d[n+1]+d[n])*h[n+1]-2*v[n+1])/(h[n+1]*h[n+1]*h[n+1])
    }
  }
  {
    if ($1==e) {
      Print(N,x,y); N=0
    }
    ++N; e=x[N]=$1; y[N]=log($2)
  }
  END {
    Print(N,x,y)
  }
'fin'
#
foreach z (`cut -f1 ${pwd}/index.tbl`)
  stderr $z
  gzip -d -c ${pwd}/mac/${z}.gz | awk -f $tmp | gzip >${pwd}/ln/${z}.gz
end
#
rm $tmp
