
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#ifndef	DATA_NUMBER_LIMIT
#define DATA_NUMBER_LIMIT	1024
#endif

#define LINE_LEN	1024

static void	Error(msg)
char		*msg;
{
	fputs(msg,stderr); fputc('\n',stderr); exit(1);
}

#define ALLOC(num)	(double *)malloc((num)*sizeof(double))

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	n,N=0,DNL=DATA_NUMBER_LIMIT;
	double	*x0,*y0,*y1,*y2,*y3,x,y0N,y1N,y2N,y3N,dx;
	char	line[LINE_LEN];

	if (argc!=1 && argc!=2) Error("usage : sinterp {dataNumberLimit}");

	if (argc==2) DNL=atoi(argv[1]);

	if ((x0=ALLOC(DNL))==NULL ||
	    (y0=ALLOC(DNL))==NULL ||
	    (y1=ALLOC(DNL))==NULL ||
	    (y2=ALLOC(DNL))==NULL ||
	    (y3=ALLOC(DNL))==NULL) Error("memory allocation error.");

	while (fgets(line,LINE_LEN,stdin)!=NULL)
	    switch(sscanf(line,"%lf %lf %lf %lf %lf",&x,&y0N,&y1N,&y2N,&y3N)) {
		case 1 :
		    if (N==0) Error("no data exists.");

		    for (n=1; n<N; n++) if (x<x0[n]) break;
		    --n; dx=x-x0[n];
		    printf("%lf\t%lf\n",
			   x,exp(y0[n]+(y1[n]+(y2[n]+y3[n]*dx)*dx)*dx));
		    break;
		case 2 :
		    y1N=0.0;
		case 3 :
		    y2N=y3N=0.0;
		case 5 :
		    if (N==DNL) Error("too many data.");

		    x0[N]=x; y0[N]=y0N; y1[N]=y1N; y2[N]=y2N; y3[N]=y3N; ++N;
		    break;
	    }

	return 0;
}
